require 'studio_game/clumsy_player'
module StudioGame
  describe ClumsyPlayer do
    before do
      @player = ClumsyPlayer.new("klutz")
    end
    
    it "only gets half the point value for each treasure" do
      @player.points.should == 0

      hammer = Treasure.new(:hammer, 50)
      @player.found_treasure(hammer)
      @player.found_treasure(hammer)
      @player.found_treasure(hammer)

      @player.points.should == 75

      crowbar = Treasure.new(:crowbar, 400)
      @player.found_treasure(crowbar)
      
      @player.points.should == 275    
      
      yielded = []
      @player.each_found_treasure do |treasure|
        yielded << treasure
      end

      yielded.should == [Treasure.new(:hammer, 75), Treasure.new(:crowbar, 200)]    
    end

    context "with boost factor" do
      before do
        @initial_health = 100
        @boost_factor   = 3
        @player = ClumsyPlayer.new("booster",@initial_health,@boost_factor)
      end
      
      it "has boost factor" do
        expect(@player.boost_factor).to eq(3)
      end

      it "gets wooted number of booster_factor times" do
        @player.w00t

        expect(@player.health).to eq(@initial_health + (@boost_factor * 15))    
      end
    end


  end
end
